
-- # import nat
-- # import fin

{--------------------------------------------------------------------------
    Vectors of a given length
 --------------------------------------------------------------------------}

data Vec (A:Set) : Nat -> Set where
  nil	       : Vec A 0
  (::) (n:Nat) : A -> Vec A n -> Vec A (suc n)

{--------------------------------------------------------------------------
    Looking up an element of a vector
 --------------------------------------------------------------------------}

(!) (A:Set)(n:Nat) : Vec A n -> Fin n -> A
(x :: xs) ! fzero  = x
(x :: xs) ! fsuc i = xs ! i

